(define (domain rpg)

    (:requirements :strips :typing :conditional-effects :negative-preconditions :equality :disjunctive-preconditions)

    (:predicates
        (hero_at ?x)
        (moster_at ?x)
        (trap_at ?x)
        (sword_at ?x)
        (visited ?x)
        (valid_move ?from ?to)
    )

    (:action move
        :parameters (?from ?to)
        :precondition (and
            (hero_at ?from) ; Hero must be at ?from square.
            (valid_move ?from ?to) ; It must to be a valid move on the board.
            (not (visited ?to)) ; The square cannot have been visited.
            (
                or
                (sword_at ?from)
                (not (moster_at ?to))
                ; The next move is valid when ?from has a sword or if the next one does not have a monster.
                ; If ?to has a monster and ?from has a sword, you can pass the monster.
            )
        )
        
        :effect (and
            (hero_at ?to) ; Hero changes position.
            (visited ?from) ; ?from has now been visited.
        )
    )
)